Index: drivers/video/aty/atyfb_base.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/aty/atyfb_base.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/aty/atyfb_base.c	22 Jul 2004 19:50:23 -0000	1.1
+++ drivers/video/aty/atyfb_base.c	4 Aug 2004 01:29:59 -0000	1.2
@@ -583,18 +687,97 @@
     crtc->xoffset = xoffset;
     crtc->yoffset = yoffset;
     crtc->bpp = bpp;
-    crtc->h_tot_disp = h_total | (h_disp<<16);
-    crtc->h_sync_strt_wid = (h_sync_strt & 0xff) | (h_sync_dly<<8) |
-			    ((h_sync_strt & 0x100)<<4) | (h_sync_wid<<16) |
-			    (h_sync_pol<<21);
-    crtc->v_tot_disp = v_total | (v_disp<<16);
-    crtc->v_sync_strt_wid = v_sync_strt | (v_sync_wid<<16) | (v_sync_pol<<21);
     crtc->off_pitch = ((yoffset*vxres+xoffset)*bpp/64) | (vxres<<19);
     crtc->gen_cntl = pix_width | c_sync | CRTC_EXT_DISP_EN | CRTC_ENABLE;
+    /* Enable doublescan mode if requested */
+    if ((vmode & FB_VMODE_MASK) == FB_VMODE_DOUBLE)
+        crtc->gen_cntl|=CRTC_DBL_SCAN_EN;
+    /* Enable interlaced mode if requested */
+    if ((vmode & FB_VMODE_MASK) == FB_VMODE_INTERLACED)
+        crtc->gen_cntl|=CRTC_INTERLACE_EN;
+#ifdef CONFIG_FB_ATY_GENERIC_LCD
+    /* We can only program the real mode parameters to the CRTC
+       if the LCD monitor is switched off. Otherwise we will have to
+       use the parameters the LCD monitor prefers, effectively setting
+       a completely different mode which simulates the requested 
+       video mode.
+     */
+    if ((info->lcd_table != 0) && ((*monitors_enabled & LCD_ON) != 0) && 
+        ((xres > info->lcd_width) || (ryres > info->lcd_height))
+       ) {
+        /* We cannot display the mode on the LCD. If the CRT is enabled
+           we can turn off the LCD.
+           If the CRT is off, it isn't a good idea to switch it on; we don't
+           know if one is connected. So it's better to fail then.
+         */
+        if (*monitors_enabled & CRT_ON) {
+            printk(KERN_INFO "Disabling lcd monitor because video mode does not fit.\n");
+            *monitors_enabled = *monitors_enabled & (~LCD_ON);
+        } else
+            FAIL("Video mode exceeds size of lcd monitor.\nConnect this computer to a conventional monitor if you really need this mode.");
+    };
+    if ((info->lcd_table == 0) || ((*monitors_enabled & LCD_ON) == 0)) {
+#endif
+        crtc->h_tot_disp = h_total | (h_disp<<16);
+        crtc->h_sync_strt_wid = (h_sync_strt & 0xff) | (h_sync_dly<<8) |
+                                ((h_sync_strt & 0x100)<<4) | (h_sync_wid<<16) |
+                                (h_sync_pol<<21);
+        crtc->v_tot_disp = v_total | (v_disp<<16);
+        crtc->v_sync_strt_wid = v_sync_strt | (v_sync_wid<<16) | (v_sync_pol<<21);
+#ifdef CONFIG_FB_ATY_GENERIC_LCD
+        /* No hardware stretching please! */
+        crtc->h_stretching = 0;
+        crtc->v_stretching = 0;
+    } else {
+        /* This is horror! When we simulate, say 640x480 on an 800x600
+           lcd monitor, the CRTC should be programmed 800x600 values for
+           the non visible part, but 640x480 for the visible part.
+           This code has been tested on a laptop with it's 800x600 lcd
+           monitor and a conventional monitor both switched on.
+           Tested modes: 640x400, 720x400, 800x600, 320x200-doublescan,
+                         800x600-interlaced
+         */
+        lcd_htotal = h_disp + info->lcd_hblank_width;
+        lcd_hsync_start = h_disp + info->lcd_right;
+        lcd_vtotal = v_disp + info->lcd_vblank_width;
+        lcd_vsync_start = v_disp + info->lcd_lower;
+        
+        crtc->h_tot_disp = (lcd_htotal) | (h_disp<<16);
+        crtc->h_sync_strt_wid = (lcd_hsync_start & 0xff) |
+                                (info->lcd_hsync_delay<<8) |
+                                ((lcd_hsync_start & 0x100)<<4) |
+                                (info->lcd_hsync_width<<16);
+        crtc->v_tot_disp = lcd_vtotal | (v_disp<<16);
+        crtc->v_sync_strt_wid = lcd_vsync_start |
+                                (info->lcd_vsync_width<<16);
+        /* To simulate the requested video mode, we use the hardware stretcher,
+           which zooms the image to the dimensions of the LCD screen. It has
+           two modes; replication and blending. Replication duplicates some
+           pixels, blending interpolates between pixels. We use blending.
+           The formula for blending is:
+              h_stretching=(source_with/dest_width)*4096
+              v_stretching=(source_lines/dest_lines)*1024
+         */
+        if (xres != info->lcd_width)
+            crtc->h_stretching = (xres*4096)/info->lcd_width;
+        else
+            crtc->h_stretching = 0;
+        if (ryres != info->lcd_height)
+            crtc->v_stretching = (ryres*1024)/info->lcd_height;
+        else
+            crtc->v_stretching = 0;
+        /* The prefered mode for the lcd is not interlaced, so disable it if
+           it was enabled. For doublescan there is no problem, because we can
+           compensate for it in the hardware stretching (we stretch half as much)
+         */
+        crtc->gen_cntl&=~CRTC_INTERLACE_EN;
+    };
+    crtc->monitors_enabled = *monitors_enabled;
+#endif
     if (M64_HAS(MAGIC_FIFO)) {
-	/* Not VTB/GTB */
-	/* FIXME: magic FIFO values */
-	crtc->gen_cntl |= aty_ld_le32(CRTC_GEN_CNTL, info) & 0x000e0000;
+        /* Not VTB/GTB */
+        /* FIXME: magic FIFO values */
+        crtc->gen_cntl |= aty_ld_le32(CRTC_GEN_CNTL, info) & 0x000e0000;
     }
     crtc->dp_pix_width = dp_pix_width;
     crtc->dp_chain_mask = dp_chain_mask;
@@ -604,18 +787,19 @@
 
 
 static int aty_crtc_to_var(const struct crtc *crtc,
-			   struct fb_var_screeninfo *var)
+                           struct fb_var_screeninfo *var)
 {
     u32 xres, yres, bpp, left, right, upper, lower, hslen, vslen, sync;
     u32 h_total, h_disp, h_sync_strt, h_sync_dly, h_sync_wid, h_sync_pol;
     u32 v_total, v_disp, v_sync_strt, v_sync_wid, v_sync_pol, c_sync;
     u32 pix_width;
-
+    u32 double_scan, interlace;
+            
     /* input */
     h_total = crtc->h_tot_disp & 0x1ff;
     h_disp = (crtc->h_tot_disp>>16) & 0xff;
     h_sync_strt = (crtc->h_sync_strt_wid & 0xff) |
-		  ((crtc->h_sync_strt_wid>>4) & 0x100);
+                  ((crtc->h_sync_strt_wid>>4) & 0x100);
     h_sync_dly = (crtc->h_sync_strt_wid>>8) & 0x7;
     h_sync_wid = (crtc->h_sync_strt_wid>>16) & 0x1f;
     h_sync_pol = (crtc->h_sync_strt_wid>>21) & 0x1;
@@ -626,7 +810,9 @@
     v_sync_pol = (crtc->v_sync_strt_wid>>21) & 0x1;
     c_sync = crtc->gen_cntl & CRTC_CSYNC_EN ? 1 : 0;
     pix_width = crtc->gen_cntl & CRTC_PIX_WIDTH_MASK;
-
+    double_scan = crtc->gen_cntl & CRTC_DBL_SCAN_EN;
+    interlace = crtc->gen_cntl & CRTC_INTERLACE_EN;
+                
     /* convert */
     xres = (h_disp+1)*8;
     yres = v_disp+1;
@@ -637,82 +823,82 @@
     lower = v_sync_strt-v_disp;
     vslen = v_sync_wid;
     sync = (h_sync_pol ? 0 : FB_SYNC_HOR_HIGH_ACT) |
-	   (v_sync_pol ? 0 : FB_SYNC_VERT_HIGH_ACT) |
-	   (c_sync ? FB_SYNC_COMP_HIGH_ACT : 0);
+           (v_sync_pol ? 0 : FB_SYNC_VERT_HIGH_ACT) |
+           (c_sync ? FB_SYNC_COMP_HIGH_ACT : 0);
 
     switch (pix_width) {
 #if 0
-	case CRTC_PIX_WIDTH_4BPP:
-	    bpp = 4;
-	    var->red.offset = 0;
-	    var->red.length = 8;
-	    var->green.offset = 0;
-	    var->green.length = 8;
-	    var->blue.offset = 0;
-	    var->blue.length = 8;
-	    var->transp.offset = 0;
-	    var->transp.length = 0;
-	    break;
-#endif
-	case CRTC_PIX_WIDTH_8BPP:
-	    bpp = 8;
-	    var->red.offset = 0;
-	    var->red.length = 8;
-	    var->green.offset = 0;
-	    var->green.length = 8;
-	    var->blue.offset = 0;
-	    var->blue.length = 8;
-	    var->transp.offset = 0;
-	    var->transp.length = 0;
-	    break;
-	case CRTC_PIX_WIDTH_15BPP:	/* RGB 555 */
-	    bpp = 16;
-	    var->red.offset = 10;
-	    var->red.length = 5;
-	    var->green.offset = 5;
-	    var->green.length = 5;
-	    var->blue.offset = 0;
-	    var->blue.length = 5;
-	    var->transp.offset = 0;
-	    var->transp.length = 0;
-	    break;
+        case CRTC_PIX_WIDTH_4BPP:
+            bpp = 4;
+            var->red.offset = 0;
+            var->red.length = 8;
+            var->green.offset = 0;
+            var->green.length = 8;
+            var->blue.offset = 0;
+            var->blue.length = 8;
+            var->transp.offset = 0;
+            var->transp.length = 0;
+            break;
+#endif
+        case CRTC_PIX_WIDTH_8BPP:
+            bpp = 8;
+            var->red.offset = 0;
+            var->red.length = 8;
+            var->green.offset = 0;
+            var->green.length = 8;
+            var->blue.offset = 0;
+            var->blue.length = 8;
+            var->transp.offset = 0;
+            var->transp.length = 0;
+            break;
+        case CRTC_PIX_WIDTH_15BPP:      /* RGB 555 */
+            bpp = 16;
+            var->red.offset = 10;
+            var->red.length = 5;
+            var->green.offset = 5;
+            var->green.length = 5;
+            var->blue.offset = 0;
+            var->blue.length = 5;
+            var->transp.offset = 0;
+            var->transp.length = 0;
+            break;
 #if 0
-	case CRTC_PIX_WIDTH_16BPP:	/* RGB 565 */
-	    bpp = 16;
-	    var->red.offset = 11;
-	    var->red.length = 5;
-	    var->green.offset = 5;
-	    var->green.length = 6;
-	    var->blue.offset = 0;
-	    var->blue.length = 5;
-	    var->transp.offset = 0;
-	    var->transp.length = 0;
-	    break;
-#endif
-	case CRTC_PIX_WIDTH_24BPP:	/* RGB 888 */
-	    bpp = 24;
-	    var->red.offset = 16;
-	    var->red.length = 8;
-	    var->green.offset = 8;
-	    var->green.length = 8;
-	    var->blue.offset = 0;
-	    var->blue.length = 8;
-	    var->transp.offset = 0;
-	    var->transp.length = 0;
-	    break;
-	case CRTC_PIX_WIDTH_32BPP:	/* ARGB 8888 */
-	    bpp = 32;
-	    var->red.offset = 16;
-	    var->red.length = 8;
-	    var->green.offset = 8;
-	    var->green.length = 8;
-	    var->blue.offset = 0;
-	    var->blue.length = 8;
-	    var->transp.offset = 24;
-	    var->transp.length = 8;
-	    break;
-	default:
-	    FAIL("Invalid pixel width");
+        case CRTC_PIX_WIDTH_16BPP:      /* RGB 565 */
+            bpp = 16;
+            var->red.offset = 11;
+            var->red.length = 5;
+            var->green.offset = 5;
+            var->green.length = 6;
+            var->blue.offset = 0;
+            var->blue.length = 5;
+            var->transp.offset = 0;
+            var->transp.length = 0;
+            break;
+#endif
+        case CRTC_PIX_WIDTH_24BPP:      /* RGB 888 */
+            bpp = 24;
+            var->red.offset = 16;
+            var->red.length = 8;
+            var->green.offset = 8;
+            var->green.length = 8;
+            var->blue.offset = 0;
+            var->blue.length = 8;
+            var->transp.offset = 0;
+            var->transp.length = 0;
+            break;
+        case CRTC_PIX_WIDTH_32BPP:      /* ARGB 8888 */
+            bpp = 32;
+            var->red.offset = 16;
+            var->red.length = 8;
+            var->green.offset = 8;
+            var->green.length = 8;
+            var->blue.offset = 0;
+            var->blue.length = 8;
+            var->transp.offset = 24;
+            var->transp.length = 8;
+            break;
+        default:
+            FAIL("Invalid pixel width");
     }
 
     /* output */
@@ -731,14 +917,30 @@
     var->vsync_len = vslen;
     var->sync = sync;
     var->vmode = FB_VMODE_NONINTERLACED;
-
+    /* In double scan mode, the vertical parameters are doubled, so we need to
+       half them to get the right values.
+       In interlaced mode the values are already correct, so no correction is
+       necessary.
+       Code has been tested in 1024x768, 43 Hz interlaced and 640x480, 60 Hz
+       doublesscan.
+    */
+    if (interlace)
+        var->vmode = FB_VMODE_INTERLACED;
+    if (double_scan) {
+        var->vmode = FB_VMODE_DOUBLE;
+        var->yres>>=1;
+        var->upper_margin>>=1;
+        var->lower_margin>>=1;
+        var->vsync_len>>=1;
+    };
+                                    
     return 0;
 }
 
 /* ------------------------------------------------------------------------- */
 
 static void atyfb_set_par(const struct atyfb_par *par,
-			  struct fb_info_aty *info)
+                          struct fb_info_aty *info)
 {
     u32 i;
     int accelmode;
@@ -749,134 +951,157 @@
     info->current_par = *par;
 
     if (info->blitter_may_be_busy)
-	wait_for_idle(info);
+        wait_for_idle(info);
     tmp = aty_ld_8(CRTC_GEN_CNTL + 3, info);
     aty_set_crtc(info, &par->crtc);
+
+#if 0
     aty_st_8(CLOCK_CNTL + info->clk_wr_offset, 0, info);
-					/* better call aty_StrobeClock ?? */
+                                        /* better call aty_StrobeClock ?? */
     aty_st_8(CLOCK_CNTL + info->clk_wr_offset, CLOCK_STROBE, info);
+#endif
+    aty_st_8(CLOCK_CNTL, 0, info);
+    aty_st_8(CLOCK_CNTL, CLOCK_STROBE | CLOCK_DIV, info);
 
     info->dac_ops->set_dac(info, &par->pll, par->crtc.bpp, accelmode);
     info->pll_ops->set_pll(info, &par->pll);
 
     if (!M64_HAS(INTEGRATED)) {
-	/* Don't forget MEM_CNTL */
-	i = aty_ld_le32(MEM_CNTL, info) & 0xf0ffffff;
-	switch (par->crtc.bpp) {
-	    case 8:
-		i |= 0x02000000;
-		break;
-	    case 16:
-		i |= 0x03000000;
-		break;
-	    case 32:
-		i |= 0x06000000;
-		break;
-	}
-	aty_st_le32(MEM_CNTL, i, info);
+        /* Don't forget MEM_CNTL */
+        i = aty_ld_le32(MEM_CNTL, info) & 0xf0ffffff;
+        switch (par->crtc.bpp) {
+            case 8:
+                i |= 0x02000000;
+                break;
+            case 16:
+                i |= 0x03000000;
+                break;
+            case 32:
+                i |= 0x06000000;
+                break;
+        }
+        aty_st_le32(MEM_CNTL, i, info);
     } else {
-	i = aty_ld_le32(MEM_CNTL, info) & 0xf00fffff;
-	if (!M64_HAS(MAGIC_POSTDIV))
-	    i |= info->mem_refresh_rate << 20;
-	switch (par->crtc.bpp) {
-	    case 8:
-	    case 24:
-		i |= 0x00000000;
-		break;
-	    case 16:
-		i |= 0x04000000;
-		break;
-	    case 32:
-		i |= 0x08000000;
-		break;
-	}
-	if (M64_HAS(CT_BUS)) {
-	    aty_st_le32(DAC_CNTL, 0x87010184, info);
-	    aty_st_le32(BUS_CNTL, 0x680000f9, info);
-	} else if (M64_HAS(VT_BUS)) {
-	    aty_st_le32(DAC_CNTL, 0x87010184, info);
-	    aty_st_le32(BUS_CNTL, 0x680000f9, info);
-	}  else if (M64_HAS(MOBIL_BUS)) {
-	    aty_st_le32(DAC_CNTL, 0x80010102, info);
-	    aty_st_le32(BUS_CNTL, 0x7b33a040, info);
-	} else {
-	    /* GT */
-	    aty_st_le32(DAC_CNTL, 0x86010102, info);
-	    aty_st_le32(BUS_CNTL, 0x7b23a040, info);
-	    aty_st_le32(EXT_MEM_CNTL,
-			aty_ld_le32(EXT_MEM_CNTL, info) | 0x5000001, info);
-	}
-	aty_st_le32(MEM_CNTL, i, info);
+        i = aty_ld_le32(MEM_CNTL, info) & 0xf00fffff;
+        if (!M64_HAS(MAGIC_POSTDIV))
+            i |= info->mem_refresh_rate << 20;
+        switch (par->crtc.bpp) {
+            case 8:
+            case 24:
+                i |= 0x00000000;
+                break;
+            case 16:
+                i |= 0x04000000;
+                break;
+            case 32:
+                i |= 0x08000000;
+                break;
+        }
+        if (M64_HAS(CT_BUS)) {
+            aty_st_le32(DAC_CNTL, 0x87010184, info);
+            aty_st_le32(BUS_CNTL, 0x680000f9, info);
+        } else if (M64_HAS(VT_BUS)) {
+            aty_st_le32(DAC_CNTL, 0x87010184, info);
+            aty_st_le32(BUS_CNTL, 0x680000f9, info);
+        }  else if (M64_HAS(MOBIL_BUS)) {
+            aty_st_le32(DAC_CNTL, 0x80010102, info);
+            aty_st_le32(BUS_CNTL, 0x7b33a040, info);
+        } else {
+            /* GT */
+            aty_st_le32(DAC_CNTL, 0x86010102, info);
+            aty_st_le32(BUS_CNTL, 0x7b23a040, info);
+            aty_st_le32(EXT_MEM_CNTL,
+                        aty_ld_le32(EXT_MEM_CNTL, info) | 0x5000001, info);
+        }
+        aty_st_le32(MEM_CNTL, i, info);
     }
     aty_st_8(DAC_MASK, 0xff, info);
 
     /* Initialize the graphics engine */
     if (par->accel_flags & FB_ACCELF_TEXT)
-	aty_init_engine(par, info);
+        aty_init_engine(par, info);
 
 #ifdef CONFIG_FB_COMPAT_XPMAC
     if (!console_fb_info || console_fb_info == &info->fb_info) {
-	struct fb_var_screeninfo var;
-	int vmode, cmode;
-	display_info.height = ((par->crtc.v_tot_disp>>16) & 0x7ff)+1;
-	display_info.width = (((par->crtc.h_tot_disp>>16) & 0xff)+1)*8;
-	display_info.depth = par->crtc.bpp;
-	display_info.pitch = par->crtc.vxres*par->crtc.bpp/8;
-	atyfb_encode_var(&var, par, info);
-	if (mac_var_to_vmode(&var, &vmode, &cmode))
-	    display_info.mode = 0;
-	else
-	    display_info.mode = vmode;
-	strcpy(display_info.name, atyfb_name);
-	display_info.fb_address = info->frame_buffer_phys;
-	display_info.cmap_adr_address = info->ati_regbase_phys+0xc0;
-	display_info.cmap_data_address = info->ati_regbase_phys+0xc1;
-	display_info.disp_reg_address = info->ati_regbase_phys;
+        struct fb_var_screeninfo var;
+        int vmode, cmode;
+        display_info.height = ((par->crtc.v_tot_disp>>16) & 0x7ff)+1;
+        display_info.width = (((par->crtc.h_tot_disp>>16) & 0xff)+1)*8;
+        display_info.depth = par->crtc.bpp;
+        display_info.pitch = par->crtc.vxres*par->crtc.bpp/8;
+        atyfb_encode_var(&var, par, info);
+        if (mac_var_to_vmode(&var, &vmode, &cmode))
+            display_info.mode = 0;
+        else
+            display_info.mode = vmode;
+        strcpy(display_info.name, atyfb_name);
+        display_info.fb_address = info->frame_buffer_phys;
+        display_info.cmap_adr_address = info->ati_regbase_phys+0xc0;
+        display_info.cmap_data_address = info->ati_regbase_phys+0xc1;
+        display_info.disp_reg_address = info->ati_regbase_phys;
     }
 #endif /* CONFIG_FB_COMPAT_XPMAC */
 #ifdef CONFIG_BOOTX_TEXT
     btext_update_display(info->frame_buffer_phys,
-			 (((par->crtc.h_tot_disp>>16) & 0xff)+1)*8,
-			 ((par->crtc.v_tot_disp>>16) & 0x7ff)+1,
-			 par->crtc.bpp,
-			 par->crtc.vxres*par->crtc.bpp/8);
+                         (((par->crtc.h_tot_disp>>16) & 0xff)+1)*8,
+                         ((par->crtc.v_tot_disp>>16) & 0x7ff)+1,
+                         par->crtc.bpp,
+                         par->crtc.vxres*par->crtc.bpp/8);
 #endif /* CONFIG_BOOTX_TEXT */
 }
 
 static int atyfb_decode_var(const struct fb_var_screeninfo *var,
-			    struct atyfb_par *par,
-			    const struct fb_info_aty *info)
+                            struct atyfb_par *par,
+                            const struct fb_info_aty *info,
+                            u32 monitors_enabled)
 {
     int err;
+    u32 pixclock,xres;
 
-    if ((err = aty_var_to_crtc(info, var, &par->crtc)) ||
-	(err = info->pll_ops->var_to_pll(info, var->pixclock, par->crtc.bpp,
-		    			 &par->pll)))
-	return err;
+    err = aty_var_to_crtc(info, var, &par->crtc, &monitors_enabled);
+    if (err == 0) {
+        /* Alert! aty_var_to_crtc can modify monitors_enabled which is
+           important for the pixclock decision */
+        pixclock = var->pixclock;
+        xres = 0;
+#ifdef CONFIG_FB_ATY_GENERIC_LCD
+        if ((info->lcd_table != 0) && ((monitors_enabled & LCD_ON) != 0)) {
+            pixclock = info->lcd_pixclock;
+            xres = var->xres;
+        };
+#endif
+        if (pixclock == 0) {
+            FAIL("Invalid pixclock");
+        } else
+            err = info->pll_ops->var_to_pll(info, pixclock, par->crtc.bpp, xres,
+	                                    &par->pll);
+    };
+    if (err != 0)
+        return err;
 
     if (var->accel_flags & FB_ACCELF_TEXT)
-	par->accel_flags = FB_ACCELF_TEXT;
+        par->accel_flags = FB_ACCELF_TEXT;
     else
-	par->accel_flags = 0;
+        par->accel_flags = 0;
 
 #if 0 /* fbmon is not done. uncomment for 2.5.x -brad */
-    if (!fbmon_valid_timings(var->pixclock, htotal, vtotal, info))
-	return -EINVAL;
+    if (!fbmon_valid_timings(pixclock, htotal, vtotal, info))
+        return -EINVAL;
 #endif
 
     return 0;
 }
 
 static int atyfb_encode_var(struct fb_var_screeninfo *var,
-			    const struct atyfb_par *par,
-			    const struct fb_info_aty *info)
+                            const struct atyfb_par *par,
+                            const struct fb_info_aty *info)
 {
     int err;
 
     memset(var, 0, sizeof(struct fb_var_screeninfo));
 
     if ((err = aty_crtc_to_var(&par->crtc, var)))
-	return err;
+        return err;
     var->pixclock = info->pll_ops->pll_to_var(info, &par->pll);
 
     var->height = -1;
@@ -889,7 +1114,7 @@
 
 
 static void set_off_pitch(struct atyfb_par *par,
-			  const struct fb_info_aty *info)
+                          const struct fb_info_aty *info)
 {
     u32 xoffset = par->crtc.xoffset;
     u32 yoffset = par->crtc.yoffset;
@@ -912,11 +1137,11 @@
     struct fb_info_aty *fb = (struct fb_info_aty *)info;
 
     if (user) {
-	fb->open++;
-	fb->mmaped = 0;
-	fb->vtconsole = -1;
+        fb->open++;
+        fb->mmaped = 0;
+        fb->vtconsole = -1;
     } else {
-	fb->consolecnt++;
+        fb->consolecnt++;
     }
 #endif
     return(0);
@@ -936,42 +1161,42 @@
     struct fb_info_aty *fb = (struct fb_info_aty *)info;
 
     if (user) {
-	fb->open--;
-	mdelay(1);
-	wait_for_idle(fb);
-	if (!fb->open) {
-		int was_mmaped = fb->mmaped;
-
-		fb->mmaped = 0;
-		if (fb->vtconsole != -1)
-			vt_cons[fb->vtconsole]->vc_mode = KD_TEXT;
-		fb->vtconsole = -1;
-
-		if (was_mmaped) {
-			struct fb_var_screeninfo var;
-
-			/* Now reset the default display config, we have no
-			 * idea what the program(s) which mmap'd the chip did
-			 * to the configuration, nor whether it restored it
-			 * correctly.
-			 */
-			var = default_var;
-			if (noaccel)
-				var.accel_flags &= ~FB_ACCELF_TEXT;
-			else
-				var.accel_flags |= FB_ACCELF_TEXT;
-			if (var.yres == var.yres_virtual) {
-				u32 vram = (fb->total_vram - (PAGE_SIZE << 2));
-				var.yres_virtual = ((vram * 8) / var.bits_per_pixel) /
-					var.xres_virtual;
-				if (var.yres_virtual < var.yres)
-					var.yres_virtual = var.yres;
-			}
-			atyfb_set_var(&var, -1, &fb->fb_info);
-		}
-	}
+        fb->open--;
+        mdelay(1);
+        wait_for_idle(fb);
+        if (!fb->open) {
+                int was_mmaped = fb->mmaped;
+
+                fb->mmaped = 0;
+                if (fb->vtconsole != -1)
+                        vt_cons[fb->vtconsole]->vc_mode = KD_TEXT;
+                fb->vtconsole = -1;
+
+                if (was_mmaped) {
+                        struct fb_var_screeninfo var;
+
+                        /* Now reset the default display config, we have no
+                         * idea what the program(s) which mmap'd the chip did
+                         * to the configuration, nor whether it restored it
+                         * correctly.
+                         */
+                        var = default_var;
+                        if (noaccel)
+                                var.accel_flags &= ~FB_ACCELF_TEXT;
+                        else
+                                var.accel_flags |= FB_ACCELF_TEXT;
+                        if (var.yres == var.yres_virtual) {
+                                u32 vram = (fb->total_vram - (PAGE_SIZE << 2));
+                                var.yres_virtual = ((vram * 8) / var.bits_per_pixel) /
+                                        var.xres_virtual;
+                                if (var.yres_virtual < var.yres)
+                                        var.yres_virtual = var.yres;
+                        }
+                        atyfb_set_var(&var, -1, &fb->fb_info);
+                }
+        }
     } else {
-	fb->consolecnt--;
+        fb->consolecnt--;
     }
 #endif
     return(0);
@@ -979,8 +1204,8 @@
 
 
 static int encode_fix(struct fb_fix_screeninfo *fix,
-		      const struct atyfb_par *par,
-		      const struct fb_info_aty *info)
+                      const struct atyfb_par *par,
+                      const struct fb_info_aty *info)
 {
     memset(fix, 0, sizeof(struct fb_fix_screeninfo));
 
@@ -993,27 +1218,27 @@
      *  Reg Block 1 (multimedia extensions) is at ati_regbase_phys-0x400
      */
     if (M64_HAS(GX)) {
-	fix->mmio_start = info->ati_regbase_phys;
-	fix->mmio_len = 0x400;
-	fix->accel = FB_ACCEL_ATI_MACH64GX;
+        fix->mmio_start = info->ati_regbase_phys;
+        fix->mmio_len = 0x400;
+        fix->accel = FB_ACCEL_ATI_MACH64GX;
     } else if (M64_HAS(CT)) {
-	fix->mmio_start = info->ati_regbase_phys;
-	fix->mmio_len = 0x400;
-	fix->accel = FB_ACCEL_ATI_MACH64CT;
+        fix->mmio_start = info->ati_regbase_phys;
+        fix->mmio_len = 0x400;
+        fix->accel = FB_ACCEL_ATI_MACH64CT;
     } else if (M64_HAS(VT)) {
-	fix->mmio_start = info->ati_regbase_phys-0x400;
-	fix->mmio_len = 0x800;
-	fix->accel = FB_ACCEL_ATI_MACH64VT;
+        fix->mmio_start = info->ati_regbase_phys-0x400;
+        fix->mmio_len = 0x800;
+        fix->accel = FB_ACCEL_ATI_MACH64VT;
     } else /* if (M64_HAS(GT)) */ {
-	fix->mmio_start = info->ati_regbase_phys-0x400;
-	fix->mmio_len = 0x800;
-	fix->accel = FB_ACCEL_ATI_MACH64GT;
+        fix->mmio_start = info->ati_regbase_phys-0x400;
+        fix->mmio_len = 0x800;
+        fix->accel = FB_ACCEL_ATI_MACH64GT;
     }
     fix->type = FB_TYPE_PACKED_PIXELS;
     fix->type_aux = 0;
     fix->line_length = par->crtc.vxres*par->crtc.bpp/8;
     fix->visual = par->crtc.bpp <= 8 ? FB_VISUAL_PSEUDOCOLOR
-				     : FB_VISUAL_DIRECTCOLOR;
+                                     : FB_VISUAL_DIRECTCOLOR;
     fix->ywrapstep = 0;
     fix->xpanstep = 8;
     fix->ypanstep = 1;
@@ -1027,15 +1252,18 @@
      */
 
 static int atyfb_get_fix(struct fb_fix_screeninfo *fix, int con,
-			 struct fb_info *fb)
+                         struct fb_info *fb)
 {
     const struct fb_info_aty *info = (struct fb_info_aty *)fb;
     struct atyfb_par par;
 
     if (con == -1)
-	par = info->default_par;
+        par = info->default_par;
     else
-	atyfb_decode_var(&fb_display[con].var, &par, info);
+        /* The monitors_enabled information is not important for
+           the calculation of the information in par that encode_fix
+           needs, so we pass a 0. */
+        atyfb_decode_var(&fb_display[con].var, &par, info, 0);
     encode_fix(fix, &par, info);
     return 0;
 }
